/* Teil von RandomXmas v1.12 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include "konstanten.h"
#include "grafikausg.h"
#include "texturen.h"

#ifndef EBENENFELD_H
#define EBENENFELD_H 1

typedef enum{typlos, baum, huegel} feldtyp;

class Feld
  {	public:
		Feld(feldtyp neutyp, int neuhoehe, int neudarunter, 
			int neudarueber, Texture* neuthistex);
		~Feld();
		void	 Invisible(short onoff);
		void     Change(feldtyp neutyp, int neuhoehe,
				 int neudarunter);
		int      Leeren();
		int 	 GetDarueber();
                feldtyp  GetTyp();
		void 	 DrawFeld(int x, int y, GLuint displaylist);
		char 	 textoben[2];
	private:
		GLUquadric *qfeld;
		feldtyp typ;
		int darunter;
		GrafikAusgabe *darueber;
		int hoehe;
		Texture *texfeld;
  };

class Ebene
  {	public:
		Ebene(int neunummer, Texture* *neutexarray);
		~Ebene();
                int  IstDortBaum(int x, int y);
		int  GetDarueber(int x, int y);
		void TrigFahrstuhl();
		void DrawEbene();
	private:
		Feld *felder[MAXFELD][MAXFELD];
		int fahrstuhl;
		GLuint startList;
		GrafikAusgabe *nummer, *zeile;
		Texture* *texarray;

		void InitFelder(int neunummer);
		void DrawGround(GLuint displayList);
  };

typedef struct 
   { 
	Ebene *spielraum[MAXEBENEN-2];
	short raumused[MAXEBENEN-2];
	Texture* texarray[NUMOFTEX];
	int   aktebene, punkte, ende, blickmann;
   } Spielraumtyp;
// texarray: 	0=texebene, 1=texhuegel, 2=texbaum, 3=texcap,
// 		4=texhead,  5=texbody,   6=texshoes


#endif

